#include "LISTE.hpp"

/*
Konstruktor zur Initialisierung der Slots.
*/



// erzeugt von US (Innovative Software) am 14.08.1991, 13:29
// letzte nderung von US am 14.08.1991, 14:41

LISTE::LISTE()
{
AnzahlElemente=0;
ErstesElement=LetztesElement=AktuellesElement=0;

}


/*
Das Erste Element der Liste wird zum aktuellen Element gemacht.
Wenn die Liste leer ist, ist das aktuelle Element 0.
Der Rckgabewert ist der Zeiger auf die Daten des aktuellen Elements, wenn die Liste nicht leer ist, sonst 0.
*/



// erzeugt von US (Innovative Software) am 14.08.1991, 13:59
// letzte nderung von US am 14.08.1991, 14:04

VOIDPTR LISTE::GoFirst()
{
AktuellesElement=ErstesElement;
if (AktuellesElement)
    return AktuellesElement->Daten;
else
    return 0;
}


/*
Das letzte Element der Liste wird zum aktuellen Element gemacht.
Wenn die Liste leer ist, ist das aktuelle Element 0.
Der Rckgabewert ist der Zeiger auf die Daten des aktuellen Elements, wenn die Liste nicht leer ist, sonst 0.
*/



// erzeugt von US (Innovative Software) am 14.08.1991, 14:04
// letzte nderung von US am 14.08.1991, 14:04

VOIDPTR LISTE::GoLast()
{
AktuellesElement=LetztesElement;
if (AktuellesElement)
    return AktuellesElement->Daten;
else
    return 0;
}


/*
Das nachfolgende Element des Aktuellen Elements der Liste wird zum aktuellen Element gemacht.
Wenn das aktuelle Element 0 ist, bleibt das aktuelle Element 0.
Der Rckgabewert ist der Zeiger auf die Daten des neuen aktuellen Elements, sonst 0.
*/



// erzeugt von US (Innovative Software) am 14.08.1991, 14:04
// letzte nderung von US am 14.08.1991, 14:08

VOIDPTR LISTE::GoNext()
{
if (AktuellesElement)
    AktuellesElement=AktuellesElement->Nachfolger;
if (AktuellesElement)
    return AktuellesElement->Daten;
else
    return 0;
}


/*
Das verhergehende Element des Aktuellen Elements der Liste wird zum aktuellen Element gemacht.
Wenn das aktuelle Element 0 ist, bleibt das aktuelle Element 0.
Der Rckgabewert ist der Zeiger auf die Daten des neuen aktuellen Elements, sonst 0.
*/



// erzeugt von US (Innovative Software) am 14.08.1991, 14:06
// letzte nderung von US am 14.08.1991, 14:07

VOIDPTR LISTE::GoPrevious()
{
if (AktuellesElement)
    AktuellesElement=AktuellesElement->Vorgaenger;
if (AktuellesElement)
    return AktuellesElement->Daten;
else
    return 0;
}


/*
Diese Methode fgt ein Neues Element in die Liste vor dem aktuellen Element ein. Wenn das Aktuelle Element 0 ist, wird das neue Element an das Ende der Liste angehangen.

Die Parameter enthalten folgende Werte:

VOIDPTR Data: Zeiger auf die Daten des neuen Elements. Wenn dieser Parameter 0 ist, wird kein neues Element eingefgt.

DELETEPROC DeleteProc: Zeiger auf eine Funktion, die vor dem Lschen des Elements aufgerufen wird. Dieser Parameter darf 0 sein.

Der Rckgabewert ist ungleich 0, wenn das Einfgen erfolgreich war. Danach ist das neue Element das aktuelle Element.

*/



// erzeugt von US (Innovative Software) am 14.08.1991, 14:08
// letzte nderung von US am 22.09.1991, 10:28

int LISTE::Insert(VOIDPTR Data, DELETEPROC DeleteProc)
{
if (!Data)
    return 0;
if (!AktuellesElement) 
    return Append(Data, DeleteProc);

LISTENELEMENT* NeuesElement;
if (AktuellesElement->Vorgaenger) {
    NeuesElement=new LISTENELEMENT(Data, AktuellesElement->Vorgaenger, AktuellesElement, DeleteProc);
    if (!NeuesElement)
        return 0;
    AktuellesElement->Vorgaenger->Nachfolger=NeuesElement;
    AktuellesElement->Vorgaenger=NeuesElement;
    AktuellesElement=NeuesElement;
} else {
    NeuesElement=new LISTENELEMENT(Data, AktuellesElement->Vorgaenger, AktuellesElement, DeleteProc);
    if (!NeuesElement)
        return 0;
    ErstesElement=NeuesElement;
    AktuellesElement->Vorgaenger=NeuesElement;
    AktuellesElement=NeuesElement;
}
AnzahlElemente++;
return 1;
}


/*
Diese Methode hngt ein Neues Element an das Ender der Liste.

Die Parameter enthalten folgende Werte:

VOIDPTR Data: Zeiger auf die Daten des neuen Elements. Wenn dieser Parameter 0 ist, wird kein neues Element angehngt.

DELETEPROC DeleteProc: Zeiger auf eine Funktion, die vor dem Lschen des Elements aufgerufen wird. Dieser Parameter darf 0 sein.

Der Rckgabewert ist ungleich 0, wenn das Anhngen erfolgreich war. Danach ist das neue Element das aktuelle Element.

*/



// erzeugt von US (Innovative Software) am 14.08.1991, 14:25
// letzte nderung von US am 22.09.1991, 11:41

int LISTE::Append(VOIDPTR Data, DELETEPROC DeleteProc)
{
if (!Data)
    return 0;

LISTENELEMENT* NeuesElement;
NeuesElement=new LISTENELEMENT(Data, LetztesElement, 0, DeleteProc);
if (!NeuesElement)
    return 0;

if (LetztesElement)
    LetztesElement->Nachfolger=NeuesElement;
else
    ErstesElement=NeuesElement;

AktuellesElement=NeuesElement;
LetztesElement=NeuesElement;

AnzahlElemente++;
return 1;
}


/*
Diese Methode liefert den Zeiger auf die Daten des aktuellen Elements zurck. Wenn das aktuelle Element 0 ist, wird eine 0 zurckgegeben.
*/



// erzeugt von US (Innovative Software) am 14.08.1991, 14:30
// letzte nderung von US am 21.09.1991, 10:52

VOIDPTR LISTE::GetCurrent()
{
if (AktuellesElement)
    return AktuellesElement->Daten;
else
    return 0;

}


/*
Destruktor. Alle zur Liste gehrenden LISTENELEMENTE und ggf. der assoziierte Speicher werden gelscht.
*/



// erzeugt von US (Innovative Software) am 14.08.1991, 14:41
// letzte nderung von US am 14.08.1991, 14:49

LISTE::~LISTE()
{
LISTENELEMENT* Element=ErstesElement;
while (Element) {
    LISTENELEMENT* Next=Element->Nachfolger;
    delete Element;
    Element=Next;
}

}


/*
Wenn das aktuelle Element ungleich 0 ist, wird es aus der Liste gelscht. Das nachfolgende Element des zu lschenden Elements wird das neue aktuelle Element.
Der Rckgabewert ist ungleich 0, wenn das Lschen erfolgreich war.
*/



// erzeugt von US (Innovative Software) am 14.08.1991, 14:49
// letzte nderung von US am 22.09.1991, 10:27

int LISTE::Delete()
{
if (!AktuellesElement)
    return 0;
if (AktuellesElement->Vorgaenger) {
    AktuellesElement->Vorgaenger->Nachfolger=AktuellesElement->Nachfolger;
} else {
    ErstesElement=AktuellesElement->Nachfolger;
}
if (AktuellesElement->Nachfolger) {
    AktuellesElement->Nachfolger->Vorgaenger=AktuellesElement->Vorgaenger;
} else {
    LetztesElement=AktuellesElement->Vorgaenger;
}
LISTENELEMENT* Next=AktuellesElement->Nachfolger;
delete AktuellesElement;
AktuellesElement=Next;
AnzahlElemente--;
return 1;

}


/*
Wenn das aktuelle Element ungleich 0 ist, wird es aus der Liste gelscht. Das nachfolgende Element des zu lschenden Elements wird das neue aktuelle Element.
Der Rckgabewert ist ungleich 0, wenn das Lschen erfolgreich war.
Die Daten des LISTENELEMENTs werden nicht gelscht!
*/



// erzeugt von US (Innovative Software) am 14.08.1991, 14:56
// letzte nderung von US am 22.09.1991, 10:27

int LISTE::Exclude()
{
if (!AktuellesElement)
    return 0;
if (AktuellesElement->Vorgaenger) {
    AktuellesElement->Vorgaenger->Nachfolger=AktuellesElement->Nachfolger;
} else {
    ErstesElement=AktuellesElement->Nachfolger;
}
if (AktuellesElement->Nachfolger) {
    AktuellesElement->Nachfolger->Vorgaenger=AktuellesElement->Vorgaenger;
} else {
    LetztesElement=AktuellesElement->Vorgaenger;
}
LISTENELEMENT* Next=AktuellesElement->Nachfolger;
AktuellesElement->Daten=0;
delete AktuellesElement;
AktuellesElement=Next;
AnzahlElemente--;
return 1;

}


/*
Gibt die Anzahl der in der Liste enthaltenen Elemente zurck.
*/



// erzeugt von US (Innovative Software) am 21.09.1991, 10:54
// letzte nderung von US am 21.09.1991, 10:55

int LISTE::GetElementCount()
{
return AnzahlElemente;
}


/*
Diese Funktion ruft fr jedes Element der Liste die 
Callback-Funktion auf, bis diese einen Wert ungleich 0 
zurckgibt oder alle Elemente abgearbeitet wurden. Der 
Rckgabewert von EnumElements ist gleich dem Rckgabewert 
des letzten Aufrufs der Callback-Funktion. Wenn die Liste leer ist, wird 0 zurckgegeben. 
 
Die Callback-Funktion mu folgende Syntax haben: 
 
long Callback(void* Data, va_list argptr); 
 
Gibt die Callback-Funktion Null zurck, wird, falls vorhanden, 
die Callback-Funktion fr das nchste Element aufgerufen. Gibt 
sie einen  Wert ungleich Null zurck, wird EnumElements abgebrochen und dieser Wert als Ergebnis von EnumElements 
zurckgegegben. 
 
*/



// erzeugt von US (Innovative Software) am 21.09.1991, 10:56
// letzte nderung von US am 22.09.1991, 10:37

long LISTE::EnumElements(LISTEENUMFUNC EnumFunc, ...)
{
va_list argptr;
va_start(argptr, EnumFunc);

long RetVal=0;
GoFirst();
VOIDPTR Data;

while (!RetVal && (Data=GetCurrent())) {
	RetVal=(*EnumFunc)(Data, argptr);
	if (!RetVal) 
		GoNext();
}

va_end(argptr);
return RetVal;
}


/*
Diese Funktion ruft fr jedes Element der Liste die Methode Delete auf. Dadurch werden alle Elemente gelscht und ihr zugehriger Speicher freigegeben, indem die zugehrige DeleteProc aufgerufen wird.
*/



// erzeugt von US (Innovative Software) am 21.09.1991, 11:08
// letzte nderung von US am 21.09.1991, 11:15

void LISTE::DeleteAll()
{
while (GoFirst())
	Delete();

}


/*
Diese Methode ruft fr alle Listenelemente die Methode Exclude auf. Dadurch wird die Liste leer, die zugehrigen LISTENELEMENTE werden gelscht, aber die zu den LISTENELEMENTEn gehrenden Daten werden nicht gelscht (die DeleteProc wird nicht aufgerufen).
*/



// erzeugt von US (Innovative Software) am 21.09.1991, 11:11
// letzte nderung von US am 21.09.1991, 11:14

void LISTE::ExcludeAll()
{
while (GoFirst())
	Exclude();
}


/*
Die Methode FindData sucht in der Liste nach dem ersten Element, da mit den Daten, auf die DataPtr zeigt, assoziiert ist. 
Wenn kein Element gefunden wurde, ist der Rckgabewert und das aktuelle Element 0, sonst ist der Rckgabewert ungleich 0 und das Aktuelle Element zeigt auf das gefundene Element.

*/



// erzeugt von US (Innovative Software) am 22.09.1991, 10:28
// letzte nderung von US am 22.09.1991, 10:34

int LISTE::FindData(VOIDPTR DataPtr)
{
return EnumElements(FindDataEnum, DataPtr);

}


/*
Enumfunktion fr FindData
*/



// erzeugt von US (Innovative Software) am 22.09.1991, 10:34
// letzte nderung von US am 22.09.1991, 10:36

long LISTE::FindDataEnum(VOIDPTR Data, va_list argptr)
{
VOIDPTR FindData=va_arg(argptr, VOIDPTR);
if (FindData==Data) 
	return 1;
else
	return 0;

}

